c Radar-Plotting. comp.: Georg Frst "Radar an Bord", Pietsch ed., 2002
c
c This program uses as input radar-distances and bearings of a ship "B"
c approaching ship "A", observed at two times, at least 6 minutes apart.
c Then it calculates the relative course KBr of B and CPA to ship A.
c Furthermore the absolute course KB and velocity VB is calculated.
c Entering a required CPA and time for a course-change, it calculates
c possible courses for ship "A" to guarantee a passage at required
c safety-distance CPA.
c
c (Note: this is not intended fro professional use, no guarantees!)
c
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
      common /com0/ pi1,zpi
      pi=3.141592653589793238d0
      grdra=2.d0*pi/360.d0
      ragrd=360.d0/(2.d0*pi)
      pi1=pi
      zpi=pi*2.d0
      iauf=0
c
      iseed=1
      rand0=iseed
      nz=1
c
c   Default_Werte fuer Input, BOOK: Fuerst,Radar an Bord, p.143; #14
      aka=300
      va=5
      th1=13
      tm1=0
      rwp1=350
      r1=3.7
      th2=13
      tm2=6
      rwp2=350
      r2=2.5
      scpa=1.5
      wt=0.

cc      open(26,file='radar-plot-ergebnis.txt')
c
      write(6,*) 'RADAR-PLOT and Evasive Manoeuvre'
      write(6,*) 'CHECK: G. Fuerst, p.78-81, Aufgb.Abb.40)'
      write(6,*)
      
      write(6,*) '(For default values, just hit RETURN to continue)'
cc This is a simplified version of a more complex program..
cc      write(6,*) 'Enter a 4-digit number ',
cc     &           'to initiate the random generator:'
cc      write(6,*) '(Falls Eingabe=1: Lsung einer Einzelaufgabe)'
cc      write(6,*)
cc      call readit(rand0)
      if(rand0 .lt. 0.0) then
       write(*,*) '~~~~~~~end of program~~~~~~~~~~~'
       close(26)
       pause
       stop
      endif
      ih=rand0/2
      ih=iabs(ih)
      iseed=ih*2+1
c
c-------------------------------------------------------
 5    continue
      if(rand0 .lt. 1.1) then
      write(*,*) '--------------------------------------------------'
      write(*,*) 'To prevent a collision at sea, with RADAR-assistance,'
      write(*,*) 'an evasive manoeuvre under Radar is calculated.'
      write(*,*) 'You must enter the own course of ship A and velocity'
      write(*,*) 'and then two observations of approaching ship B.'
      write(*,*)
      write(*,*) 'Definitions:'
      write(*,*) 'KA=true course of ship A, VA=velocity of ship A'
      write(*,*) 'KBr=relative course of ship B, as seen from ship A'
      write(*,*) 'KB=true course of ship B, VB=velocity of ship B'
      write(*,*) 'StB=starboard,  BB=port-side ("backbord")'
      write(*,*) 'CPA= Closest Point of Approaach = minimal distance'
      write(*,*) '(CPA required is typically about 1 nautical mile)'!'
      write(*,*)
      call input(aka,va,th1,th2,tm1,tm2,tmh,tmm,rwp1,rwp2,r1,r2,scpa,wt)
      write(*,*) 'OBSERVATION:'
      call result(aka,va,th1,th2,tm1,tm2,tmh,tmm,rwp1,rwp2,r1,r2,scpa)
       write(*,*) '<Hit RETURN to continue...>'
cc      read(*,*) haux
      read(*,*)
      haux=1
      if (haux.le. 0.5) stop
      do 799 i9=1,50
        write(*,*)
 799  continue
       write(*,*) '##########  Own Course etc. as before ! ##### '
       goto 5
      endif
c-------------------------------------------------------
c
      pause
      stop
 900  format(1x,'Own ship: rwK=',i4,' Grad,   Fahrt=',f5.1,' kts')
 901  format(1x,'Zeit_1= ',i2,':',i2,'  SP=',i4,'  Dist=',f5.1,' sm')
 902  format(1x,'Zeit_2= ',i2,':',i2,'  SP=',i4,'  Dist=',f5.1,' sm')
 903  format(1x,'~~~ Manoever ~~~' )
 904  format(1x,'Zeit_M= ',i2,':',i2)
 905  format(1x,'Gewuenschter CPA=',f5.1 )
 951  format(1x,i5,'. Initial Random Number=',i15)
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function random(iseed)
c       standard random number generator
      iseed=iseed*16807
      if(iseed.lt.0) iseed=iseed+2147483647+1
      random=.46566128e-9*iseed
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine myname(day,month,year)
      implicit real*8(a-h,o-z)
      real*8 month
      character xcar
      md=day
      mm=month
      my=year
      if(md.eq.20.and.mm.eq.4.and.my.eq.1944) then
      write(*,*) '                     COPYRIGHT :'
      write(*,*) '          <author: Heiner Mueller-Krumbhaar>'
      write(*,*) '     <address: Poststr.5, D-40789 Monheim, Germany>'
      write(*,*)
      write(*,*) '         ------  hit [ENTER] to continue :'
      xcar='-'
      read(5,'(a)') xcar
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readit(xxx)
      implicit real*8 (a-h,o-z)
      character*8 aaa,bbb
      bbb=''
      aaa=''
      write(6,901) xxx
      read(5,'(a)') aaa
cc      write(*,*) aaa
      if(aaa.eq.bbb) return
      read(aaa,*) xxx
      if(xxx.gt.  9999.) xxx= 99999.
      if(xxx.lt. -9999.) xxx=-99999.
      return
 901  format('        [ Default: ',f10.0,' ]    Input=')
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readint(xxx)
      implicit real*8 (a-h,o-z)
      character*8 aaa,bbb
      bbb=''
      aaa=''
      nx=xxx+0.5
      write(6,901) nx
      read(5,'(a)') aaa
      if(aaa.eq.bbb) return
      read(aaa,*) xxx
c rounding
      nx=xxx+0.5
      xxx=nx
      if(xxx.gt.  9999.) xxx= 99999.
      if(xxx.lt. -9999.) xxx=-99999.
      return
 901  format('        [ Default: ',i6,' ]    Input=')
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine readif(xxx)
      implicit real*8 (a-h,o-z)
      character*8 aaa,bbb
      bbb=''
      aaa=''
      write(6,901) xxx
      read(5,'(a)') aaa
cc      write(*,*) aaa
      if(aaa.eq.bbb) return
      read(aaa,*) xxx
      if(xxx.gt.  9999.) xxx= 99999.
      if(xxx.lt. -9999.) xxx=-99999.
      return
 901  format('        [ Default: ',f6.1,' ]    Input=')
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine
     & input(aka,va,th1,th2,tm1,tm2,tmh,tmm,rwp1,rwp2,r1,r2,scpa,wait)
      implicit real*8 (a-h,o-z)
      dimension xa(2),xb(2),xva(2),xvb(2)
      character*3 stbtxt, bbtxt,txt1,txt2
      common pi,grdra,ragrd
      pi=3.141592653589793238d0
      grdra=2.d0*pi/360.d0
      ragrd=360.d0/(2.d0*pi)
c
      write(*,*) 'Own ship (=A):'
      write(*,*) 'Input course A:'
      call readint(aka)
      write(*,*) 'Velocity A'
      call readif(va)
      write(*,*)
      write(*,*) 'Two RADAR-observations B1,B2 of approaching ship B'
      write(*,*) 'are required, at least 6 minutes apart:'
      write(*,*)
      write(*,*) '--------------------------------------------------'
      write(*,*) 'Approaching ship (=B):'
      write(*,*) 'Time of observation B-1, hhmm (four digits): '
      h1=100.d0*th1+tm1
      call readint(h1)
      th1=int(h1/100.d0)
      tm1=h1-th1*100.d0
      write(*,*) 'Tru Bearing (rwP1): B-1'
      call readint(rwp1)
      write(*,*) 'Distance B1'
      call readif(r1)
      write(*,*) '--------------------------------------------------'
      write(*,*) 'Time of observation B-2, hhmm (four digits):'
      h2=100.d0*th2+tm2
      if(tm2.gt.60.) then
      th2=th2+1.d0
      tm2=tm2-60.d0
      h2=100.d0*th2+tm2
      endif
      call readint(h2)
      th2=int(h2/100.d0)
      tm2=h2-th2*100.d0
      write(*,*) 'Tru Bearing (rwP1): B-2'
      call readint(rwp2)
      write(*,*) 'Distance B2'
      call readif(r2)
      write(*,*) '########## RADAR-PLOT Result: #####################'
      write(*,*) 'Minimal CPA to maintain (Distance)=',scpa
      call readif(scpa)
      if(scpa<0.001) stop
      nx=wait+0.5
      wait=nx
      write(*,*) 'Evasive manoeuver after  minutes='
      call readint(wait)
      if(wait<0.) wait=0.
      hm=h2 + wait
      tmh=int(hm/100.d0)
      tmm=hm-tmh*100.d0
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine
     & result(aka,va,th1,th2,tm1,tm2,tmh,tmm,rwp1,rwp2,r1,r2,scpa)
      implicit real*8 (a-h,o-z)
      dimension xa(2),xb(2),xva(2),xvb(2)
      character*3 stbtxt, bbtxt,txt1,txt2
      common pi,grdra,ragrd
      pi=3.141592653589793238d0
      grdra=2.d0*pi/360.d0
      ragrd=360.d0/(2.d0*pi)
c input
      stbtxt='StB'
      bbtxt ='BB '
c
      tmah=tmh
      tmam=tmm
c
      icon=0
c
c zeitunterschiede und distanzen
      t1=60*th1+tm1
      t2=60*th2+tm2
      tm=60*tmah+tmam
      dt=abs(t2-t1)
      call pepos(rwp1,r1,x1,y1)
      call pepos(rwp2,r2,x2,y2)
      dx=sqrt((x1-x2)**2+(y1-y2)**2)
      da=va*dt/60.d0
c geschwindigkeit vbr
      vbr=60*dx/dt
c relativer kurs kbr
      call  peilg(x1,y1,x2,y2,peil)
      akbr=peil
c cpa
      x0=0
      y0=0
      call cpa(x0,y0,x1,y1,peil,cpap,cpar)
c absoluter kurs akb, und fusspunkt
      akai=180.d0+aka
      call wnorm(akai)
      call vecpkt(x1,y1,akai,da,xfus,yfus)
      db=sqrt((xfus-x2)**2+(yfus-y2)**2)
      call  peilg(xfus,yfus,x2,y2,peil)
      akb=peil
      vb=60*db/dt
c zwischenausgabe
      ka=round(aka,0)
      vaq=round(va,1)
      rwp1q=round(rwp1,0)
      rwp2q=round(rwp2,0)
      dxq=round(dx,1)
      daq=round(da,1)
      kbr=round(akbr,0)
      vbrq=round(vbr,1)
      cpapq=round(cpap,0)
      cparq=round(cpar,1)
      kb=round(akb,0)
      vbq=round(vb,1)
      th1q=int(th1+0.01)+tm1/100.d0
      th1q=round(th1q,2)
      th2q=int(th2+0.01)+tm2/100.d0
      th2q=round(th2q,2)
      rr1=round(r1,1)
      rr2=round(r2,1)
c integers
      nth1=th1
      ntm1=tm1
      nrwp1q=rwp1q
      nth2=th2
      ntm2=tm2
      nrwp2q=rwp2q
      ncpapq=cpapq
      write( 6,*) 'Course, Velocity, CPA, etc.:'
      write( 6,*) 'KA=',ka,'  VA=',vaq,' kt'
      write( 6,*)
     &     'hh:mm_1 ',nth1,':',ntm1,'  rwP1=',rwp1q,' r1=',rr1,' sm'
      write( 6,*)
     &     'hh:mm_2 ',nth2,':',ntm2,'  rwP2=',rwp2q,' r2=',rr2,' sm'
cc      write( 6,*) 'dt=',dt ,'   dx,da=',dxq,daq
      write( 6,*) 'KBr =',kbr,'  VBr=',vbrq,' kt'
      write( 6,*) 'CPA_direction.=',ncpapq,'  Dist.=',cparq,' sm'
      write( 6,*) 'KB  =',kb,'  VB=',vbq,' kt'
c
c manoeverpunkt
      dtm=tm-t2
      dm=vbr*dtm/60.d0
      dam=va*dtm/60.d0
      call vecpkt(x2,y2,akbr,dm,xh,yh)
      xm=xh
      ym=yh
c peilungen zum soll-cpa
      call pospe(xm,ym,rwpm,rm)
      rwpm0=rwpm
      rwpm=rwpm+180.d0
      call wnorm(rwpm)
      if(rm.lt.1.d-39) rm=1.d-39
      phi=dasin(scpa/rm) * ragrd
      phi=dabs(phi)
      peilm1=rwpm+phi
      peilm2=rwpm-phi
      call wnorm(peilm1)
      call wnorm(peilm2)
c schnitt des kreises 1 um fusspkt r=da mit gerade(peilm1) durch x2,y2
      peilm=peilm1
      rhelp=1.d0
      call vecpkt(x2,y2,peilm,rhelp,xhelp,yhelp)
      call gerad(xhelp,yhelp,x2,y2,a,b)
      call xgk(a,b,xfus,yfus,da,xh1,yh1,xh2,yh2,ier1)
c   if(ier1.ne.0) write( 6,*) '###### ???? kein Schnitt1 ??? ###',ier1
      call peilg(xfus,yfus,xh1,yh1,peil11)
      call peilg(xfus,yfus,xh2,yh2,peil12)
c schnitt des kreises 2 um fusspkt r=da mit gerade(peilm2) durch x2,y2
      peilm=peilm2
      rhelp=1.d0
      call vecpkt(x2,y2,peilm,rhelp,xhelp,yhelp)
      call gerad(xhelp,yhelp,x2,y2,a,b)
      call xgk(a,b,xfus,yfus,da,xh1,yh1,xh2,yh2,ier2)
c   if(ier2.ne.0) write( 6,*) '###### ???? kein Schnitt2 ??? ###',ier2
      call peilg(xfus,yfus,xh1,yh1,peil21)
      call peilg(xfus,yfus,xh2,yh2,peil22)
      cpam1=peilm1+90.d0
      cpam2=peilm2-90.d0
      call wnorm(cpam1)
      call wnorm(cpam2)
c endausgabe
      call seqmin(aka,peil11,peil12)
      call seqmin(aka,peil21,peil22)
      cpam1q=round(cpam1,0)
      cpam2q=round(cpam2,0)
      pqilm1=round(peilm1,0)
      pqil11=round(peil11,0)
      pqil12=round(peil12,0)
      pqilm2=round(peilm2,0)
      pqil21=round(peil21,0)
      pqil22=round(peil22,0)
      zp=round(rwpm0,0)
      zd=round(rm,1)
      delk=akbr-aka
cc      write(*,*) '# delk, akbr, aka', delk,akbr,aka
      call wnorm(delk)
      if(delk.le.90.d0 .or. delk.gt.270.d0) then
       write( 6,*) '<KA, KBr in same direction>'
      txt2=stbtxt
      txt1=bbtxt
      else
       write( 6,*) '<KA, KBr in opposite direction>'
      txt1=stbtxt
      txt2=bbtxt
      endif

      write( 6,*) '###################################################'
      write( 6,*) 'EVASIVE MANOEUVRE:'
      itmah=tmah+0.01
      itmam=tmam+0.01
cc      write( 6,*) 'Time hh:mm_M',tmah,':',tmam
      write(6,901) itmah,itmam
      izp=zp+0.5
      write( 6,*) 'Ship B: Bearing=',izp,'  Distance=',zd
      write( 6,*) 'NEW COURSE ship A:'
c
      if(scpa.gt.rm) then
        write( 6,*) '??? ship B ist already too close, Dist.=',zd
        return
      endif
      if(scpa.le.cparq) then
       write( 6,*)'NO danger of collision,CPA=',cparq,' > CPAmin=',scpa
      write( 6,*)'###################################################'
       read(*,*)
       return
      endif
c
      if(ier1.eq.0) then
       write( 6,*) txt1,'  ===>  KA=',pqil11,' resp.',pqil12
      else
       write( 6,*) txt1,'  ===>  KA=   <Velocity-change !?>'
      endif
         ncpam1q=cpam1q
cc       write( 6,*) '     CPA-Richtg.=',ncpam1q
      if(ier2.eq.0) then
       write( 6,*) txt2,'  ===>  KA=',pqil21,' resp.',pqil22
      else
       write( 6,*) txt2,'  ===>  KA=   <Velocity-change !?>'
      endif
cc       write( 6,*) '     CPA-direction=',cpam2q
      seitp=rwp2-aka
      if(seitp.lt.0.  ) seitp=seitp+360.
      if(seitp.gt.360.) seitp=seitp-360.
      if(seitp.gt.90. .and. seitp.lt.180.) then
cc      if(delk.ge.270.d0 .and. delk.le.360.d0) then
       write( 6,*) '<no turn to Starboard>'
      else
       write( 6,*) '<no turn to port-side>'
      endif
      s1=67.5d0
      s2=360.d0-s1
      if(seitp.gt.112.5  .and. seitp.lt.(360.-112.5)) then
c      if(delk.lt.s1 .or. delk.gt.s2) then
       write( 6,*) '<B is attempting to overtake>'
      endif
      write( 6,*) '###################################################'
      write( 6,*) ' '
      return
 901  format(1x,'Time hh:mm =',i2,':',i2)
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine wnorm(peil)
c umwandlung peilung in position
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
 1    continue
      ind=0
      if(peil.lt.0.d0) then
      ind=1
      peil=peil+360.d0
      endif
      if(peil.gt.360.d0) then
      ind=1
      peil=peil-360.d0
      endif
      if(ind.ne.0) goto 1
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pepos(rwp9,r9,x9,y9)
c umwandlung peilung in position
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr pepos>'
      wi=rwp9*grdra
      x9=r9*cos(wi)
      y9=r9*sin(wi)

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pospe(x9,y9,rwp9,r9)
c umwandlung position in peilung
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr pospe>'
      r9=sqrt(x9*x9+y9*y9)
      if(x9.eq.0.d0) x9=1.d-39
      wi=datan(y9/x9)
      rwp9=wi*ragrd
c quadrantenpruefung
      if(x9.lt.0.d0  .and.  y9.lt. 0.d0) rwp9=rwp9-180.d0
      if(x9.lt.0.d0  .and.  y9.gt. 0.d0) rwp9=rwp9+180.d0
      call wnorm(rwp9)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine shift2(x8,y8,x9,y9,x0,y0,xn,yn)
c zweipunkte verschieben x8 geht nach x0(fest),dann x9 nach xn
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr shift2>'
      dx=x0-x8
      dy=y0-y8
      x0=x8+dx
      y0=y8+dy
      xn=x9+dx
      yn=y9+dy
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine gerad(x1,y1,x2,y2,a,b)
c aus 2 Punkten eine Gerade bestimmen y=ax+b; peil=winkel
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr gerade>'
      dy=y2-y1
      dx=x2-x1
      if(abs(dx).lt.1.d-39) dx=1.d-39
      a=dy/dx
      b=(y2+y1-a*(x2+x1))/2.d0
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine peilg(x1,y1,x2,y2,peil)
c aus 2 Punkten eine peilg bestimmen von x1 nach x2
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr peilg>'
      dy=y2-y1
      dx=x2-x1
c
      if(dabs(dx).gt.dabs(dy)) then
        if(abs(dx).lt.1.d-39) dx=1.d-39
        a=dy/dx
        peil=datan(a)*ragrd
        if(dx.lt.0.d0) peil=180.d0+peil
      else
        if(abs(dy).lt.1.d-39) dy=1.d-39
        ah=dx/dy
        peilh=datan(ah)*ragrd
        peil=90.d0-peilh
        if(dy.lt.0.d0) peil=270.d0-peilh
      endif
      call wnorm(peil)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine cpa(x0,y0,x1,y1,peil,cpap,cpar)
c aus einem Punkt x1+peil den Closest Point of Approach zu x0
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr cpa>'
c x0 in den ursprung legen
      x00=0
      y00=0
      call shift2(x0,y0,x1,y1,x00,y00,xn,yn)
c Richtung x0-x1 ermitteln
      call pospe(xn,yn,rwp1,r1)
      rwp1i=rwp1-180.d0
      call wnorm(rwp1i)
      alfa=peil-rwp1i
      cpar=dabs(sin(alfa*grdra)*r1)
      if(alfa.gt.180.d0) alfa=alfa-360.d0
      cpap=peil+90.d0
      if(alfa.lt.0.d0) cpap=peil-90.d0
      call wnorm(cpap)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine xgg(a1,b1,a2,b2,xh,yh,ier)
c Schnitt von zwei geraden
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr schnitt gerade-gerade>'
      ier=0
      if(a1.eq.a2) then
       ier=1
       return
      endif
      xh=(b1-b2)/(a2-a1)
      yh=a1*xh+b1
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine xgk(a,b,x0,y0,r,xh1,yh1,xh2,yh2,ier)
c Schnitt von gerade und kreis
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr schnitt gerade-kreis>'
      ier=0
      disk=2*a*y0*x0-2*x0*a*b+2*b*y0-y0**2-b**2+r**2+(r**2-x0**2)*a**2
      if(disk.lt.0.d0) then
       ier=1
        xh1=0
        xh2=0
        yh1=0
        yh2=0
       return
      endif
      dh=sqrt(disk)
      fh=a*y0+x0-a*b
      xh1=(fh+dh)/(1+a**2)
      xh2=(fh-dh)/(1+a**2)
      yh1=a*xh1+b
      yh2=a*xh2+b
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine vecpkt(x1,y1,peil1,r1,xh,yh)
c von x1,y1 aus in richtung peil1 mit distanz r1 zu neuem punkt xh,yh
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr vecpkt>'
      xh=x1+r1*cos(peil1*grdra)
      yh=y1+r1*sin(peil1*grdra)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine sequhr(p0,p1,p2)
c sortiert peilungen im uhrzeigersinn, p0,pn1,pn2
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr sequhr>'
      call wnorm(p0)
      h1=p1-p0
      h2=p2-p0
      call wnorm(h1)
      call wnorm(h2)
      pn1=h1
      pn2=h2
      if(pn1.gt.pn2) then
      pn1=h2
      pn2=h1
      endif
      p1=pn1+p0
      p2=pn2+p0
      call wnorm(p1)
      call wnorm(p2)
      call wnorm(p0)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine seqmin(p0,p1,p2)
c sortiert peilungen im uhrzeigersinn, p0,pn1,pn2
      implicit real*8 (a-h,o-z)
      common pi,grdra,ragrd
c      write(26,*) '<sr seqmin>'
      call wnorm(p0)
      h1=p1-p0
      h2=p2-p0
      call wnorm(h1)
      call wnorm(h2)
      if(h1.gt.180.d0) h1=h1-360.d0
      if(h2.gt.180.d0) h2=h2-360.d0
      pn1=h1
      pn2=h2
      if(abs(pn1).gt.abs(pn2)) then
      pn1=h2
      pn2=h1
      endif
      p1=pn1+p0
      p2=pn2+p0
      call wnorm(p1)
      call wnorm(p2)
      call wnorm(p0)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function round(xxx,idec)
c rundung auf idec dezimalen
      implicit real*8 (a-h,o-z)
c      write(26,*) '<fct round>'
      if(idec.eq.0) then
        round=int(xxx+0.5d0)
        return
      endif
      f=10**idec
        round=int(f*xxx+0.5d0)/f
      return
      end

